package org.tasks.injection

import android.os.Bundle
import androidx.appcompat.app.AppCompatActivity
import org.tasks.locale.Locale
import org.tasks.themes.Theme
import org.tasks.themes.ThemeColor
import javax.inject.Inject

abstract class ThemedInjectingAppCompatActivity protected constructor() : AppCompatActivity() {
    @Inject lateinit var tasksTheme: Theme
    @Inject protected lateinit var themeColor: ThemeColor

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        tasksTheme.applyThemeAndStatusBarColor(this)
        title = null
    }

    init {
        Locale.getInstance(this).applyOverrideConfiguration(this)
    }
}